#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/Xatom.h>

Display *dpy;            
Window root, win;
int scrn;
struct tm *tmval;
char color[10]="gray";
char color_bg[10]="darkblue";
int howmuch;
int draw_border;

struct Button {
	char title[15];
	char cmd[60];
	int beginx, endx;
};

struct Button buttons[16];

GC gc,gc2,gc3,gc4;
Font font;
XFontStruct* font_;
char *window_name={"BadBar"}; 
int x,y,width,height;

void calculateBadBar(){
	// This is runed once in the begin
	int i, xoff;
	xoff = 0;

	for(i=0; i<howmuch; i++){
		buttons[i].beginx = xoff;
		xoff += XTextWidth(font_ , buttons[i].title, strlen(buttons[i].title)) + 8;
		buttons[i].endx = xoff;
		buttons[i+1].beginx = xoff;
	}
}

int drawBadBar(char real, int mouseOverX){
	int i, xoff;
	if(real) XClearWindow(dpy, win);
	xoff = 2;

	for(i=0; i<howmuch; i++){
		// Do a fucking highlite
		if(real && mouseOverX == i){
			XFillRectangle(dpy, win, gc, buttons[i].beginx+2,0,(buttons[i].endx-buttons[i].beginx)-3,height);
		}

		if(real && mouseOverX == i) {
			XDrawString(dpy, win, gc2, xoff+2, 12, buttons[i].title , strlen(buttons[i].title));
		}else if(real){
			XDrawString(dpy, win, gc, xoff+2, 12, buttons[i].title , strlen(buttons[i].title));
		}
		xoff = buttons[i].endx;	
		if(real) XDrawLine(dpy, win, gc, xoff, 1, xoff, height);
		xoff += 2;
	}
	// Draw borders
	if(real && draw_border) {
		XDrawLine(dpy, win, gc3, 0, 0, width, 0);
		XDrawLine(dpy, win, gc3, 0, 0, 0, height);	
		XDrawLine(dpy, win, gc4, 1, height-1, width, height-1);
		XDrawLine(dpy, win, gc4, width-1, 1, width-1, height);	
	}
	return xoff-2;
}

void del_nl(char * text){
        int len = strlen(text) - 1;     
        text[len] == '\n' ? text[len] = '\0' : 0;
}

void del_comment(char * text){
        int len = strlen(text);
        int i;

        /* Search */
        for(i=0; i<len; i++) if(text[i] == '#' && text[i-1] != '\\') text[i] = '\0';
}

void del_lspaces(char * text){
        int len = strlen(text)-1;
        int i;
        
        /* Search backwards */
        for(i=len; i>0; i--){
                if(text[i]==' ' || text[i] == '\t') text[i] = '\0';
                else break;
        }
}

void del_bspaces(char * text){
        int len = strlen(text);
        int i,j,ii;

        /* Search */
        for(i=0; i<len; i++){
                if(text[i] != ' ' && text[i] != '\t') break;
        }
        /* Cut */
        for(j=i,ii=0; ii<len-i; ii++,j++){
                text[ii] = text[j];
        }
        text[ii] = '\0';
}

void del_spaces(char * text){
        del_lspaces(text);
        del_bspaces(text);
}

void read_conf(char path[]){
	FILE *fp;
	char var[256];
	char variable[20], value[60];
	int i,j,line,foo,ivar,ival;

	if(!(fp = fopen(path, "r+"))) {
		printf("Cant open %s!\n",path);
		exit(0);
	}
	
	line = 0;
	while(fgets(var,256,fp)){
		del_nl(var);            /* Delete \n at the end */
        del_comment(var);       /* Remove comments */

		if(strlen(var)>1){
			foo = 0;
			ival =0;
			for(i=0; i<strlen(var); i++){
				if(var[i] == '='){ 
					foo=1;
					ival = 0;
					i++;
				}
				
				if(foo!=1){
					variable[ival] = var[i];
					variable[ival+1] = '\0';
				}
				else{
					value[ival] = var[i];
					value[ival+1] = '\0';
				}
				ival++;
			}	
			del_spaces(variable);
			del_spaces(value);
			
			sprintf(buttons[line].title,"%s",variable);
			sprintf(buttons[line].cmd,"%s",value);
					
			line++;
		}
		howmuch = line;
	}
	fclose(fp);
}

/* Now do this by fork()ing twice so we don't have to worry about SIGCHLDs */
void spawn(const char cmd[]) {
        pid_t pid;

        if (dpy)
                putenv(dpy);
        if (!(pid = fork())) {
                setsid();
                switch (fork()) {
                        case 0: system(cmd);
                        default: _exit(0);
                }
        }
        if (pid > 0)
                wait(NULL);
}

unsigned long GetColor(char *color)
{  
  Colormap cmap;
  XColor c0, c1;
  cmap = DefaultColormap(dpy, 0);
  XAllocNamedColor(dpy, cmap, color, &c1, &c0);
  return(c1.pixel);
}

unsigned long MakeBorderColor(char *color, char fgbg){
	Colormap cmap;
	char bordercolor[8] = {0,};
	XColor c0, c1;
	unsigned short r,g,b;

	cmap = DefaultColormap(dpy, 0);
	XAllocNamedColor(dpy, cmap, color, &c1, &c0);
	r = c1.red;
	g = c1.green;
	b = c1.blue;
	
	// If leftupper
	if(fgbg == 1){
		if(r+20000 <= 65535 && g+20000 <= 56635 && b+20000 <= 56635){
			r+=20000; g+=20000; b+=20000;
		}else{
			// Just white
			r = g = b = 56635;
		}
	}
	// If bottomright
	else{
		if(r-40000 >= 0 && g-40000 >= 0 && b-40000 >= 0){
			r-=40000; g-=40000; b-=40000;
		}else{
			// Just black
			r = g = b = 0;
		}
	}

	r = r/256;
	g = g/256;
	b = b/256;
	
	sprintf(bordercolor, "#%lX%lX%lX",r,g,b);
	
	XAllocNamedColor(dpy, cmap, bordercolor, &c1, &c0);
	return c1.pixel;
}

void BadBar_Event(XButtonEvent *e){
	int i;
	switch(e->button){
		case Button1:
			/* Check place */
			for(i=0; i<howmuch; i++){
				if(e->x > buttons[i].beginx && e->x < buttons[i].endx){
					spawn(buttons[i].cmd);
					break;
				}
			}	
			drawBadBar(1,i);
			break;
	}
}

int main(int argc, char **argv){	
	int i, id, curId;
	char cfg[50];	
	char myFont[70];

	XEvent ev;
	XSetWindowAttributes attr;

	draw_border = 1;
	sprintf(cfg,"%s/.badbar", getenv("HOME"));
	sprintf(myFont,"-misc-fixed-*-*-*-*-18-*-*-*-*-*-*-*");
	width = 200;
	height = 15;
	x = 1;
	y = 1;

	/* Parse argv */
    for (i=1; i < argc; i++) {
       if (!strcmp(argv[i],"-g") || !strcmp(argv[i],"--geometry")){
          XParseGeometry(argv[i+1],&x,&y,&width,&height);
       }
	   else if (!strcmp(argv[i],"-fg")){
		  sprintf(color,"%s",argv[i+1]);
	   }
	   else if (!strcmp(argv[i],"-bg")){
		  sprintf(color_bg,"%s",argv[i+1]);
	   }	
	   else if (!strcmp(argv[i],"-cfg")){
		  sprintf(cfg,"%s",argv[i+1]);
	   }
	   else if (!strcmp(argv[i],"-f")){
		  sprintf(myFont,"%s",argv[i+1]);
	   }
	   else if (!strcmp(argv[i],"-b")){
		  draw_border = 1;
	   }	
	   else if (!strcmp(argv[i],"+b")){
		  draw_border = 0;
	   }
       else if (!strcmp(argv[i],"-h") || !strcmp(argv[i],"--help")) {
          printf("usage: BadBar [--geometry -f[ont] -fg -bg -cfg]\n");
          exit(0);
       }
    }

	/* Config */
	read_conf(cfg);

	dpy = XOpenDisplay(NULL);
  	scrn = DefaultScreen(dpy);
	root = RootWindow(dpy,scrn);	
	font = XLoadFont(dpy, myFont);
	font_ = XLoadQueryFont(dpy, myFont);
	calculateBadBar();
	width = drawBadBar(0,-1);
	win = XCreateSimpleWindow(dpy,root,x,y,width,height,0,0,GetColor(color_bg));
	XStoreName(dpy,win,window_name);
	gc = XCreateGC(dpy,win,0,NULL);
	gc2 = XCreateGC(dpy,win,0,NULL);
	gc3 = XCreateGC(dpy,win,0,NULL);
	if(draw_border) gc4 = XCreateGC(dpy,win,0,NULL);
	
	XSetForeground(dpy,gc,GetColor(color));
	XSetBackground(dpy,gc,GetColor(color_bg));
	XSetForeground(dpy,gc2,GetColor(color_bg));
	XSetBackground(dpy,gc2,GetColor(color));
	if(draw_border) {
		XSetForeground(dpy,gc3,MakeBorderColor(color_bg,1));
		XSetForeground(dpy,gc4,MakeBorderColor(color_bg,2));
	}

  	XSetFont(dpy, gc, font);
  	XSetFont(dpy, gc2, font);
	attr.event_mask = ButtonPressMask|ButtonReleaseMask|LeaveWindowMask|ExposureMask|PointerMotionMask;
	
	XChangeWindowAttributes(dpy, win, CWEventMask, &attr);
	drawBadBar(1,-1);
	XMapWindow(dpy,win);
	XFlush(dpy);

	while(1){ 
   		 XNextEvent(dpy, &ev);
         switch (ev.type) {
             case ButtonPress:
                	BadBar_Event(&ev.xbutton); 
				break;
			 case Expose:
                    drawBadBar(1,-1); 
				break;
			 case LeaveNotify:
					curId = -1;
					drawBadBar(1,-1);	
				break;
			 case MotionNotify:
					for(id=0; id<howmuch; id++){
						if(buttons[id].beginx <= ev.xmotion.x && buttons[id].endx >= ev.xmotion.x) break;
					}

			        if(id != curId) {
						curId = id;
						drawBadBar(1,curId); 
					}
				break;
		}
	}
	return 0;
}
